#!/bin/bash

PLATFORM=PEAR_2605_X64_LINUX
LOG_PATH=/tmp/scripts.log
INSTALL_PATH=""

SCRIPT_PATHES=(
  ${INSTALL_PATH}/etc/pear/pear_scripts/check_config.sh   # check config
  ${INSTALL_PATH}/etc/pear/pear_scripts/watchdog.sh       # watchdog 
  ${INSTALL_PATH}/etc/pear/pear_scripts/dispatch.sh       # dispatched from server
  ${INSTALL_PATH}/etc/pear/pear_scripts/docker_traffic.sh # 
)

SCRIPT_TOGGLES=(
  1           # /etc/pear/pear_scripts/check_config.sh
  0           # /etc/pear/pear_scripts/watchdog.sh
  1           # /etc/pear/pear_scripts/dispatch.sh
  0           # /etc/pear/pear_scripts/docker_traffic.sh
)

SCRIPT_BACKGROUND=(
  0           # /etc/pear/pear_scripts/check_config.sh
  1           # /etc/pear/pear_scripts/watchdog.sh
  1           # /etc/pear/pear_scripts/dispatch.sh
  1           # /etc/pear/pear_scripts/docker_traffic.sh
)

# check files and toggles
if [[ ${#SCRIPT_PATHES[@]} -ne ${#SCRIPT_TOGGLES[@]} ]]; then
  datetime=`date "+%Y-%m-%d %H:%M:%S"`
  echo "${datetime} [FATAL] incorrect params"
  exit 1
fi

# do
for i in $(seq 0 ${#SCRIPT_PATHES})
do
  # check if close by toggles
  if [[ ${SCRIPT_TOGGLES[$i]} -ne 1 ]]; then
    continue
  fi

  # check if exist
  if [[ ! -f ${SCRIPT_PATHES[$i]} ]]; then
    datetime=`date "+%Y-%m-%d %H:%M:%S"`
    echo "${datetime} [ERROR] expected to run ${SCRIPT_PATHES[$i]}, but not exist"
    continue
  fi

  # check if running
  ps_result=`ps -ef | grep ${SCRIPT_PATHES[$i]} | grep -v grep`
  if [[ -n ${ps_result} ]]; then
    datetime=`date "+%Y-%m-%d %H:%M:%S"`
    echo "${datetime} [INFO ] ${SCRIPT_PATHES[$i]} is already running"
    continue
  fi

  # run 
  chmod +x ${SCRIPT_PATHES[$i]}
  datetime=`date "+%Y-%m-%d %H:%M:%S"`
  echo "${datetime} [INFO ] running script: ${SCRIPT_PATHES[$i]}"
  if [[ ${SCRIPT_BACKGROUND[$i]} -eq 0 ]]; then
    ${SCRIPT_PATHES[$i]} ${PLATFORM}
  else
    ${SCRIPT_PATHES[$i]} ${PLATFORM} &
  fi
done

echo "scripts done"
